"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cryptography = __importStar(require("@liskhq/lisk-cryptography"));
const constants_1 = require("./constants");
const utils_1 = require("./utils");
const validateInputs = ({ secondPassphrase, }) => {
    if (typeof secondPassphrase !== 'string') {
        throw new Error('Please provide a secondPassphrase. Expected string.');
    }
};
exports.registerSecondPassphrase = (inputs) => {
    validateInputs(inputs);
    const { passphrase, secondPassphrase, timeOffset } = inputs;
    const { publicKey } = cryptography.getKeys(secondPassphrase);
    const transaction = {
        type: 1,
        fee: constants_1.SIGNATURE_FEE.toString(),
        asset: {
            signature: {
                publicKey,
            },
        },
    };
    return utils_1.prepareTransaction(transaction, passphrase, secondPassphrase, timeOffset);
};
//# sourceMappingURL=1_register_second_passphrase.js.map