"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./constants");
const utils_1 = require("./utils");
const validateInputs = ({ username }) => {
    if (!username || typeof username !== 'string') {
        throw new Error('Please provide a username. Expected string.');
    }
    if (username.length > constants_1.USERNAME_MAX_LENGTH) {
        throw new Error(`Username length does not match requirements. Expected to be no more than ${constants_1.USERNAME_MAX_LENGTH} characters.`);
    }
};
exports.registerDelegate = (inputs) => {
    validateInputs(inputs);
    const { passphrase, secondPassphrase, timeOffset, username } = inputs;
    const transaction = {
        type: 2,
        fee: constants_1.DELEGATE_FEE.toString(),
        asset: {
            delegate: {
                username,
            },
        },
    };
    return utils_1.prepareTransaction(transaction, passphrase, secondPassphrase, timeOffset);
};
//# sourceMappingURL=2_register_delegate.js.map