'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.verifyMessage = exports.signMessage = exports.getAddressFromPublicKey = exports.getKeys = exports.decryptPassphrase = exports.encryptPassphrase = exports.decryptMessage = exports.encryptMessage = undefined;

var _liskCryptography = require('@liskhq/lisk-cryptography');

var _liskCryptography2 = _interopRequireDefault(_liskCryptography);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const encryptMessage = exports.encryptMessage = ({ message, passphrase, recipient }) => _liskCryptography2.default.encryptMessageWithPassphrase(message, passphrase, recipient); /*
                                                                                                                                                                                  * LiskHQ/lisk-commander
                                                                                                                                                                                  * Copyright © 2017–2018 Lisk Foundation
                                                                                                                                                                                  *
                                                                                                                                                                                  * See the LICENSE file at the top-level directory of this distribution
                                                                                                                                                                                  * for licensing information.
                                                                                                                                                                                  *
                                                                                                                                                                                  * Unless otherwise agreed in a custom licensing agreement with the Lisk Foundation,
                                                                                                                                                                                  * no part of this software, including this file, may be copied, modified,
                                                                                                                                                                                  * propagated, or distributed except according to the terms contained in the
                                                                                                                                                                                  * LICENSE file.
                                                                                                                                                                                  *
                                                                                                                                                                                  * Removal or modification of this copyright notice is prohibited.
                                                                                                                                                                                  *
                                                                                                                                                                                  */
const decryptMessage = exports.decryptMessage = ({
	cipher,
	nonce,
	passphrase,
	senderPublicKey
}) => ({
	message: _liskCryptography2.default.decryptMessageWithPassphrase(cipher, nonce, passphrase, senderPublicKey)
});

const encryptPassphrase = exports.encryptPassphrase = ({ passphrase, password }) => {
	const encryptedPassphraseObject = _liskCryptography2.default.encryptPassphraseWithPassword(passphrase, password);
	const encryptedPassphrase = _liskCryptography2.default.stringifyEncryptedPassphrase(encryptedPassphraseObject);
	return { encryptedPassphrase };
};

const decryptPassphrase = exports.decryptPassphrase = ({ encryptedPassphrase, password }) => {
	const encryptedPassphraseObject = _liskCryptography2.default.parseEncryptedPassphrase(encryptedPassphrase);
	const passphrase = _liskCryptography2.default.decryptPassphraseWithPassword(encryptedPassphraseObject, password);
	return { passphrase };
};

const { getKeys } = _liskCryptography2.default;

exports.getKeys = getKeys;
const getAddressFromPublicKey = exports.getAddressFromPublicKey = publicKey => ({
	address: _liskCryptography2.default.getAddressFromPublicKey(publicKey)
});

const signMessage = exports.signMessage = ({ message, passphrase }) => _liskCryptography2.default.signMessageWithPassphrase(message, passphrase);

const verifyMessage = exports.verifyMessage = ({ publicKey, signature, message }) => ({
	verified: _liskCryptography2.default.verifyMessageWithPublicKey({
		publicKey,
		signature,
		message
	})
});